Globals [ trades
          trades-c
          trades-b

          total-trade-money
          total-trade-money-c
          total-trade-money-b

          average-price
          average-price-c
          average-price-b

          gini-index-reserve
          poor-turtles
          celebrities
          sum-money
          sum-toys
          gini-ave
          gini
          population
          seed-of-randomness
         ]


Turtles-own [ toys
              crayons
              black-boards
              money
              price
              price-c
              price-b
              wealth
              all-wealth
              price-up
              price-down
              class-ranking
              f-test ]


to setup
  clear-all
  reset-ticks    ; required if we turn on ticks.
  ifelse lock-random-seed = false
      [ set seed-of-randomness new-seed
        set simulation_random-seed seed-of-randomness ]
      [ set seed-of-randomness simulation_random-seed ]

  random-seed seed-of-randomness
  set population Number-of-Agents

;;;;;;;;;;;;;;Patch Setup;;;;;;;;;;;;;;

  ask patches [ set pcolor 55 ]

;;;;;;;;;;;;;Turtle Setup;;;;;;;;;;;;;;

  set-default-shape turtles "person"
  create-turtles Number-of-Agents [ set color black
                                    move-to one-of patches ]
  ask turtles [ set money 100
                set toys 5
                set crayons 30
                set black-boards 15
                set price 10
                set price-up 1.0101
                set price-down .99
                set price-c 10
                set price-b 10 ]

end


;;;;;;;;;;;Main Procedure;;;;;;;;;;;;;;


to go


  if fitness-test != "None" or fitness-test != "Mutate-only"
                      [ rank-turtles
                        let poor-definition population * Poor-%
                        let rich-definition population * Rich-%
                        set poor-turtles turtles with [ class-ranking < poor-definition ]
                        set celebrities turtles with [ class-ranking > rich-definition ]]

  ask turtles [ set heading random 360
                fd 1
                repeat number-of-trades [ trade-blackboards
                                          trade-toys
                                          trade-crayons ]
                if fitness-test != "None"
                           [ if random Price-Mutate = 0 [ set price-up price-up + random-float .01 - random-float .01
                                                          if price-up < 1 [ set price-up 1 ]]
                             if random Price-Mutate = 0 [ set price-down price-down + random-float .01 - random-float .01
                                                          if price-down > 1 [ set price-down 1 ]
                                                          if price-down < .001 [ set price-down .001 ]]

                             if fitness-test != "Mutate only" [ ask poor-turtles
                                 [ if random imitate-price = 0
                                      [ let celeb one-of celebrities
                                                          set price [ price ] of celeb
                                                          If price-connection = true [ set price-c [ price-c ] of celeb ]
                                                          If price-connection = true [ set price-b [ price-b ] of celeb ]
                                                          if imitate-price-changes > 0 and random imitate-price-changes = 0
                                                             [ set price-up [ price-up ] of celeb
                                                               set price-down [ price-down ] of celeb
                                                               set price-up price-up + random-float .01 - random-float .01
                                                               if price-up < 1 [ set price-up 1 ]
                                                               set price-down price-down + random-float .01 - random-float .01
                                                               if price-down > 1 [ set price-down 1 ]
                                                               if price-down < 0 [ set price-down 0 ]]]]]]
                If Inventory-pricing = true and price < (2 * average-price)
                   [ if toys > desired-toy-stock-level [ change-price-down ]
                     if toys < desired-toy-stock-level [ change-price-up ]]
                If Inventory-pricing = true and price < (2 * average-price-b )
                   [ if black-boards > Desired-Blackboard-Stock-Level + 3 [ change-price-down-b ]
                     if black-boards < Desired-Blackboard-Stock-Level [ change-price-up-b ]]
                If Inventory-pricing = true and price < (2 * average-price-c)
                   [ if crayons > desired-crayon-stock-level + 5 [ change-price-down-c ]
                     if crayons < desired-crayon-stock-level [ change-price-up-c ]]

                if fitness-test = "Money" [ set f-test money ]
                if fitness-test = "Toys x Price + Money" [ set f-test money + (toys * average-price) ]
                if fitness-test = "Toy asset only" [ set f-test toys * average-price ]]

  ask turtles [ set all-wealth money + ( toys * average-price )
                if wealth-definition = "Toys" [ set wealth toys ]
                if wealth-definition = "Money only" [ set wealth money ]
                if wealth-definition = "Toys x Price + Money" [ set wealth all-wealth ]
                if wealth-definition = "Blackboards" [ set wealth black-boards ]
                if wealth-definition = "Crayons" [ set wealth crayons ]]



  tick
  chart
  if ticks = stop-simulation [ stop ]


end


to trade-toys

                 let selling-turtle min-one-of other turtles in-radius market-sight with [ toys > 0 ] [ price ]
                 if selling-turtle = nobody [ stop]
                 let sellers-price 0
                 ask selling-turtle [ if price <= [ money] of myself
                                         [ set toys toys - 1
                                           set money money + price
                                           set sellers-price price
                                           if toys > desired-toy-stock-level [ change-price-down ]
                                           if toys < desired-toy-stock-level [ change-price-up ]
                                           ask myself [ set money money - sellers-price
                                                        set toys toys + 1
                                                        set trades trades + 1
                                                        set total-trade-money total-trade-money + sellers-price
                                                        if perfect-pricing = true [ if toys > desired-toy-stock-level [ change-price-down ]
                                                                                    if toys < desired-toy-stock-level [ change-price-up ]]
                                                        ]]]


end

to trade-crayons

                 let selling-turtle min-one-of other turtles in-radius market-sight with [ crayons > 0 ] [ price-c ]
                 if selling-turtle = nobody [ stop]
                 let sellers-price 0
                 ask selling-turtle [ if price-c <= [ money] of myself
                                         [ set crayons crayons - 1
                                           set money money + price-c
                                           set sellers-price price-c
                                           if crayons > desired-crayon-stock-level + 5 [ change-price-down-c ]
                                           if crayons < desired-crayon-stock-level [ change-price-up-c ]
                                           ask myself [ set money money - sellers-price
                                                        set crayons crayons + 1
                                                        set trades-c trades-c + 1
                                                        set total-trade-money-c total-trade-money-c + sellers-price
                                                        if perfect-pricing = true [ if crayons > desired-crayon-stock-level + 5 [ change-price-down-c ]
                                                                                    if crayons < desired-crayon-stock-level [ change-price-up-c ]]
                                                        ]]]



end

to trade-blackboards

                 let selling-turtle min-one-of other turtles in-radius market-sight with [ black-boards > 0 ] [ price-b ]
                 if selling-turtle = nobody [ stop]
                 let sellers-price 0
                 ask selling-turtle [ if price-b <= [ money] of myself
                                         [ set black-boards black-boards - 1
                                           set money money + price-b
                                           set sellers-price price-b
                                           if black-boards > Desired-Blackboard-Stock-Level + 3 [ change-price-down-b ]
                                           if black-boards < Desired-Blackboard-Stock-Level [ change-price-up-b ]
                                           ask myself [ set money money - sellers-price
                                                        set black-boards black-boards + 1
                                                        set trades-b trades-b + 1
                                                        set total-trade-money-b total-trade-money-b + sellers-price
                                                        if perfect-pricing = true [ if black-boards > Desired-Blackboard-Stock-Level + 3 [ change-price-down-b ]
                                                                                    if black-boards < Desired-Blackboard-Stock-Level [ change-price-up-b ]]
                                                        ]]]


end

to rank-turtles
  let counter 0
  foreach sort-by [ [?1 ?2] -> [f-test] of ?1 < [f-test] of ?2 ] turtles
        [ [?1] -> ask ?1 [ set counter counter + 1
                           set class-ranking counter ]]
end

to change-price-up
  set price price * price-up
end

to change-price-down
  set price price * price-down
  if price < .5 [ set price .5 ]
end

to change-price-up-c
  ifelse pricing-connection = true [ set price-c price-c * price-up ]
                                   [ set price-c price-c * 1.0101 ]
end

to change-price-down-c
  ifelse pricing-connection = true [set price-c price-c * price-down ]
                                   [set price-c price-c * .99 ]
  if price-c < .5 [ set price-c .5 ]
end

to change-price-up-b
  ifelse pricing-connection = true [ set price-b price-b * price-up ]
                                   [ set price-b price-b * 1.0101 ]
end

to change-price-down-b
  ifelse pricing-connection = true [ set price-b price-b * price-down ]
                                   [ set price-b price-b * .99 ]
  if price-b < .5 [ set price-b .5 ]
end

to-report top-10%
  report sum [ wealth ] of max-n-of (count turtles * 0.10) turtles [ wealth ]
end

to-report bottom-50%
  report sum [ wealth ] of min-n-of (count turtles * 0.50) turtles [ wealth ]
end



to chart


  if trades > 0 [ set average-price total-trade-money / trades ]
  if trades-c > 0 [ set average-price-c total-trade-money-c / trades-c ]
  if trades-b > 0 [ set average-price-b total-trade-money-b / trades-b ]


    ;;;;;;;;; to update gini
  let sorted-wealths sort [wealth] of turtles
  let total-wealth sum sorted-wealths
  let wealth-sum-so-far 0
  let index 0
  set gini-index-reserve 0


  repeat Number-of-Agents [
    set wealth-sum-so-far (wealth-sum-so-far + item index sorted-wealths)
    set index (index + 1)
    set gini-index-reserve
    gini-index-reserve +
    (index / Number-of-Agents) -
    (wealth-sum-so-far / total-wealth) ]
  set gini ( gini-index-reserve / Number-of-Agents ) / 0.5


  set-current-plot "Gini Coefficient"
  set-current-plot-pen "gini"
  plot gini
  set-current-plot-pen "0.5"
  plot .5

  set-current-plot "Number of Trades"
  plot trades

  set-current-plot "Average Price Toys"
  set-current-plot-pen "price"
  plot average-price

  set-current-plot "Average Price Crayons"
  set-current-plot-pen "price"
  plot average-price-c

  set-current-plot "Average Price Blackboards"
  set-current-plot-pen "price"
  plot average-price-b

  set-current-plot "Maximum money"
  plot max [ money ] of turtles

  set-current-plot "Poverty %"
  plot count turtles with [ toys < 2 and money < 2 ] / count turtles

  set-current-plot "Maximum toys"
  plot max [ toys ] of turtles

  set-current-plot "Money + (toys x Price)"
  plot max [ all-wealth ] of turtles

  set-current-plot "Wealth by percent"
  set-current-plot-pen "top-10%"
  plot top-10%
  set-current-plot-pen "bottom-50%"
  plot bottom-50%


  set trades 0
  set trades-c 0
  set trades-b 0
  set total-trade-money 0
  set total-trade-money-c 0
  set total-trade-money-b 0
end
@#$#@#$#@
GRAPHICS-WINDOW
637
85
955
404
-1
-1
10.0
1
10
1
1
1
0
1
1
1
-15
15
-15
15
0
0
1
Iterations
30.0

BUTTON
50
35
114
68
Setup
Setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
123
35
186
68
Go
Go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
31
104
203
137
Number-of-Agents
Number-of-Agents
0
5000
400.0
10
1
NIL
HORIZONTAL

SLIDER
31
217
203
250
Stop-Simulation
Stop-Simulation
0
60000
6000.0
100
1
NIL
HORIZONTAL

MONITOR
804
410
950
455
Total Money
sum [ money ] of turtles
2
1
11

MONITOR
967
410
1113
455
Total Toys
sum [ Toys ] of turtles
17
1
11

PLOT
218
103
418
253
Number of Trades
NIL
NIL
0.0
200.0
0.0
0.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" ""

PLOT
20
256
220
406
Average Price Toys
Time
Price
0.0
200.0
0.0
0.0
true
false
"" ""
PENS
"price" 1.0 0 -16777216 true "" ""
"divider" 1.0 0 -2674135 true "" ""

PLOT
420
103
620
253
Gini Coefficient
NIL
NIL
0.0
200.0
0.0
1.0
true
false
"" ""
PENS
"gini" 1.0 0 -16777216 true "" ""
"0.5" 1.0 0 -955883 true "" ""

SLIDER
31
142
203
175
Market-sight
Market-sight
1
25
1.0
1
1
NIL
HORIZONTAL

PLOT
429
569
629
719
Maximum Money
NIL
NIL
0.0
200.0
0.0
0.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" ""

PLOT
19
568
219
718
Poverty %
NIL
NIL
0.0
200.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" ""

PLOT
224
568
424
718
Maximum Toys
NIL
NIL
0.0
200.0
0.0
0.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" ""

PLOT
636
570
836
720
Money + (Toys x Price)
NIL
NIL
0.0
200.0
0.0
0.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" ""

CHOOSER
523
411
658
456
Wealth-Definition
Wealth-Definition
"Money only" "Toys x Price + Money" "Toys" "Blackboards" "Crayons"
0

SLIDER
241
10
413
43
Price-Mutate
Price-Mutate
0
1000
180.0
10
1
NIL
HORIZONTAL

SLIDER
31
179
203
212
Number-of-Trades
Number-of-Trades
1
10
1.0
1
1
NIL
HORIZONTAL

PLOT
842
570
1171
720
Wealth by Percent
NIL
NIL
0.0
200.0
0.0
100.0
true
true
"" ""
PENS
"Top-10%" 1.0 0 -2674135 true "" ""
"Bottom-50%" 1.0 0 -16777216 true "" ""

PLOT
20
411
420
561
Wealth Histogram
Wealth
Agents
0.0
500.0
0.0
30.0
true
false
"" ""
PENS
"default" 5.0 1 -10899396 false "" "set-plot-y-range 0 40\nhistogram [ wealth ] of turtles"

MONITOR
425
412
514
457
Gini-Coefficient
gini
2
1
11

SLIDER
964
167
1152
200
Desired-Toy-Stock-Level
Desired-Toy-Stock-Level
1
7
3.0
1
1
NIL
HORIZONTAL

SLIDER
419
10
582
43
Imitate-price
Imitate-price
2
100
10.0
2
1
NIL
HORIZONTAL

SLIDER
419
46
583
79
Imitate-price-changes
Imitate-price-changes
0
50
2.0
1
1
NIL
HORIZONTAL

SLIDER
586
47
758
80
Poor-%
Poor-%
.01
rich-%
0.5
.01
1
NIL
HORIZONTAL

SLIDER
585
10
757
43
Rich-%
Rich-%
Poor-%
.99
0.95
.01
1
NIL
HORIZONTAL

BUTTON
668
489
806
522
Generate New Seed
set Simulation_Random-Seed new-seed
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
220
256
420
406
Average Price Crayons
Time
Price
0.0
200.0
0.0
10.0
true
false
"" ""
PENS
"price" 1.0 0 -16777216 true "" ""
"divider" 1.0 0 -2674135 true "" ""

PLOT
420
256
620
406
Average Price Blackboards
Time
Price
0.0
200.0
0.0
0.0
true
false
"" ""
PENS
"price" 1.0 0 -16777216 true "" ""
"divider" 1.0 0 -2674135 true "" ""

SWITCH
668
526
806
559
Lock-random-seed
Lock-random-seed
1
1
-1000

INPUTBOX
522
489
664
549
Simulation_Random-Seed
1.627354422E9
1
0
Number

CHOOSER
242
47
413
92
Fitness-Test
Fitness-Test
"None" "Money" "Toys x Price + Money" "Toy asset only" "Mutate only"
1

SWITCH
814
527
946
560
Inventory-Pricing
Inventory-Pricing
1
1
-1000

SLIDER
965
204
1153
237
Desired-Crayon-Stock-Level
Desired-Crayon-Stock-Level
1
40
15.0
1
1
NIL
HORIZONTAL

SLIDER
966
268
1155
301
Desired-Blackboard-Stock-Level
Desired-Blackboard-Stock-Level
1
20
7.0
1
1
NIL
HORIZONTAL

TEXTBOX
968
70
1118
155
Initial Stock Levels\n\nToys - 5\nCrayons - 30\nBlackboards - 15
14
0.0
1

SWITCH
814
488
946
521
Perfect-Pricing
Perfect-Pricing
1
1
-1000

TEXTBOX
976
242
1126
260
Range 5 (Setting + 5)\n
11
0.0
1

TEXTBOX
976
309
1126
327
Range 3 (Setting + 3)
11
0.0
1

SWITCH
967
330
1107
363
Pricing-Connection
Pricing-Connection
1
1
-1000

SWITCH
967
369
1108
402
Price-Connection
Price-Connection
0
1
-1000

@#$#@#$#@
## WHAT IS IT?

This is a modification of the Toy Trader where the number of goods traded is increased to three. It is used as an experimental tool to explore the emergent behaviour of basic trade in the presence of more than one product.

This model accompanies the book: **Economics for a Fairer Society: Going Back to Basics Using Agent-Based Models**


## HOW IT WORKS

The agents start with 5 Toys, 30 Crayons, 15 blackboards, and 100 money. Each agent seeks to purchase products at the lowest price from another agent within its detection range. Using prices, the agents attempt to reach a certain stock levels for each item. It is possible in invoke evolution via a fitness test. The fitness test causes poor agents to copy the pricing strategies of rich agents.

## HOW TO USE IT

Press **[Setup]** and then **[Go]**. 
Pressing **[Go]** while the simulation is running stops the simulation.

## Controls

### Buttons

**Setup** - randomly places the user set number of agents in the environment.

**Run** - starts the simulation.

**Generate-New Seed** - pressing this button will cause a new random generator seed to appear in the _Simulation-Random-Seed_ window. See _Lock-Random-Seed_.

### Sliders, Switches, etc.

**Desired-Blackboard-Stock-Level** - determines the inventory point of blackboards around which the agents raise and lower their prices. There is a inventory range in which the agent does not alter prices. The slider marks the lower bound and 3 added to the number to mark the upper bound.

**Desired-Crayon-Stock-Level** - determines the inventory point of crayons around which the agents raise and lower their prices. There is a inventory range in which the agent does not alter prices. The slider marks the lower bound and 5 added to the number to mark the upper bound.

**Desired-Toy-Stock-Level** - determines the inventory point of toys around which the agents raise and lower their prices. The number of the slider marks the inventory level where the agent does not alter their price.

**Fitness-Test** - determines which fitness test, if any, is activated. It is also possible to have the agents mutate their pricing code without any evolutionary pressures (mutate only).

**Graph-Interval** - allows the user to skip iterations in graphing. This is useful when making very long runs.

**Imitate-Price** - turns on a fitness test of wealth as defined by the Wealth-Calculation. The lower the number, the higher the probability poorer agents imitate the price of richer agents. Rich and poor agents are defined by the Rich-% and Poor-% sliders. For example, if the Rich-% slider is set to .95, the richest are those with more wealth than 95% of the other agents. If the Poor-% slider is set to .50, the poor are defined as those poorer than 50% of the other agents.

**Imitate-Price-Changes** - sets the probability of whether a poor agent imitating a rich agent's prices will also imitate a mutated version of the rich agent's pricing strategy.

**Inventory-Pricing** - changes the price code so that at the beginning of every turn, each agent alters their price according to their inventory.

**Lock-Random-Seed** - when turned on, inputs number in the _Simulation-Random-Seed_ field as the seed for the random number generator. This allows the user to exactly repeat particularly interesting experiments. If _Lock-Random-Seed_ is turned off, the _Simulation-Random-Seed_ will display the random seed the simulator chose for that run. The user can manually input random seed into the _Simulation-Random-Seed_ display, set _Lock-Random-Seed_ to 'on', and the simulator will setup based on that number.

**Market-Sight** - sets the distance in patch radii that an agent can detect prices and stock in other agents.

**Number-of-Trades** - set how many times an agent trades each iteration.

**Perfect-Pricing** - after a purchase, agents check their inventory and alter their selling price accordingly. 

**Price-Connection** - when turned on and when a fitness test is turned on, the poorer agents will also emulate the prices of blackboards and crayons that the celebrity agents are using.

**Price-Mutate** - determines the rate at which the pricing algorithms to mutate. The lower the number, the higher the probability of mutation.

**Pricing-Connection** - when turned on and if a fitness test is used, the poorer agents will use the same markups and markdowns in the crayone and blackboard markets that they use in the toy market.

**Rich-%** and **Poor-%** - determine the definition of rich and poor for the purposes of evolution. The rich are defined as agents whose wealth (see Wealth-Calculation) is ranked higher than Rich-%, while the poor are agents with wealth ranked as lower than Poor-%

**Wealth-Calculation** - tells the simulator what kind of wealth to use to calculate the Gini-coefficient (a measure of 'fairness' - 0 is perfectly equal wealth distribution and 1 is perfectly unequal). 

**Wealth-Definition** - determines what is included in the wealth calculation for the purposes of display of the Wealth by Percent, Gini coefficient and the Wealth Histogram charts.

### Plots

Graphs are all plotted each iteration with the number of iterations on the x axis and the variable on the y axis.



**Average Price** - sums the value of all trades and divides by the number of trades.

**Gini coefficient** - displays the Gini coefficient (see _Wealth-definition_)

**Maximum Money** - shows the amount of money possessed by the agent with the most money.

**Maximum Toys** - shows the number of toys possessed by the agent with the most toys.

**Money + (Toys x Price)** - shows maximum money + (toys x price) possessed by any agent.

**Number of Trades** - counts the number of successful trades.

**Poverty %** - shows the number of agents with < 2 toys and < 2 money divided by the population.

**Wealth by Percentage** - orders the agents by wealth (see _Wealth-definition_) and then calculates the aggregate wealth of the top 10% and the bottom 50%.

**************************************************************************************

**Wealth Histogram** - shows the histogram for wealth (see _Wealth-definition_) for the last iteration only. There is no history.

### Monitors

**Gini** - shows the exact Gini coefficient for the last iteration. (see _Wealth-definition_)

**Simulation-Random-Seed** - displays the last seed used for the random number generator, unless _Generate-New Seed_ has been pushed.

**Total Money** - displays the total number of money in the system.

**Total Toys** - displays the total number of toys in the system.



## CREDITS AND REFERENCES

Copyright Tim Gooding 2019.

This model is licensed by the Creative Commons Attribution-NonCommercial-ShareAlike License ( http://creativecommons.org/licenses/by-nc-sa/4.0/ ). This states that you may copy, distribute, and transmit the work under the condition that you give attribution to Gooding 2019, your use is for non-commercial purposes, and you release any work derived from this work under the same license agreement.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="experiment" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="5005000"/>
    <metric>gini-ave</metric>
    <enumeratedValueSet variable="Evolve">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Number-of-Trades">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Graph-Interval">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Number-of-Agents">
      <value value="400"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Stop-Simulation">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Market-sight">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Celebrity">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Include-Birds-in-Wealth?">
      <value value="0"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
